Subject: Re: [PATCH RFC v2 0/7] Introduce Rust and announce that it will become mandatorty

From: Patrick Steinhardt <[email-masked]>
Date: Wed, 10 Sep 2025 10:21:25 +0200

On Tue, Sep 09, 2025 at 10:12:39AM +0100, Phillip Wood wrote:
> On 05/09/2025 15:28, Patrick Steinhardt wrote:
> > On Fri, Sep 05, 2025 at 03:14:25PM +0100, Phillip Wood wrote:
> > > 
> > > It looks like this version does include the necessary Makefile changes which
> > > is great. I do think though, that for the test balloon to be valuable, we
> > > need make building with rust the default with an error message that tells
> > > people how to build without rust if that fails. Otherwise it is easy for
> > > people building on platforms without rust support to miss that we're going
> > > to be making it mandatory soon.
> > 
> > I have a plan layed out in the BreakingChanges document that mentions
> > how I'm proposing to do the transition:
> > 
> >    1. We introduce it with auto-detection for Meson and default-disabled
> >       for our Makefile in Git 2.52.
> 
> I'm not sure how much this helps us. You've said elsewhere that you don't
> want to be inundated with bug reports which is fair enough, but I'm fairly
> skeptical that we're going to get enough people enabling this get a useful
> amount of early feedback. So I wonder if it would be better just to bite the
> bullet and enable it by default from the start. I think I saw Elijah making
> a similar argument elsewhere in this thread.

The patch series may not be ready for all platforms yet though. Windows
support is still untested and probably not working, so I first need to
get that done. This is basically the reason why I'm proposing to have it
auto-detected at first: I want to be able to iterate without breaking
any platforms yet.

How about we do a compromise: we initially introduce it
default-disabled, but default-enable it in the next release already
instead of first tying it to `-Dbreaking_changes=true`? That would
accelerate the proposed timeline a bit.

Patrick